

//--- Array utils ----------

function Arr()
{
    this.remove = function( array, item )
    {
        var i = array.indexOf( item );
        if( i>-1 ) array.splice( i, 1 );
    }
}
Arr = new Arr();


//--- General utils --------------

//Check for an overlap between two objects.
//(depth is the depth of overlap required)
Obj.prototype.IsOverlap = function( obj, depth )
{
    depth = (depth ? depth : 0);
    x1 = this._left; y1 = this._top; w1 = this.GetWidth(); h1 = this.GetHeight();
    x2 = obj._left; y2 = obj._top; w2 = obj.GetWidth(); h2 = obj.GetHeight();
    if( x2 < x1+w1-depth && x2+w2 > x1+depth && y2+h2 > y1+depth && y2 < y1+h1-depth )
        return true;
    else
        return false;
}

//--- Effects ----------------------

//Explode a control.
Obj.prototype.Explode = function()
{
    this.w = this.GetWidth()*2, this.h = this.GetHeight()*2;
    this.imgBack = app.CreateImage( null, this.w, this.h );
    this.imgBack.SetPosition( this._left-this.w/4, this._top-this.h/4, this.w, this.h );
    this._parent.AddChild( this.imgBack );
    this.player = app.CreateMediaPlayer();
    this.player.SetOnReady( _Cb(this,"_PlayExplode") );
	this.player.SetFile( "/Sys/Snd/Explode.mp3" );
    this._DoExplode( this, 0 );
}

//Play explode sound.
Obj.prototype._PlayExplode = function()
{
    this.player.Play( 0 );
}

//Show an animated explosion.
Obj.prototype._DoExplode = function( _this, startFrame )
{
    if( startFrame!=null ) { 
        _this.explodeFrame = startFrame;
        _this.Hide();
    }
    
	if( _this.explodeFrame < 5 ) {
		var file = "Explode" + (++_this.explodeFrame) + ".png";
		_this.imgBack.SetImage( "/Sys/Img/" + file, _this.w, _this.h );
		setTimeout( function(){_this._DoExplode(_this,null)}, 100 );
	}
	else { 
		_this.explodeFrame = 1;
		_this._parent.DestroyChild( _this.imgBack );
		_this.player.Destroy();
	}
}

